var Harvest = { };

Harvest.Game = function(game) {
    this.gnome;
    this.spellEffects;
    this.ringGroup = [];
    this.text;
};

Harvest.Game.prototype = {
    preload: function() {
        this.load.image('gnome', 'images/gnome.png');
        this.load.image('sparkle', 'images/sparkle.png');
        this.load.image('ring', 'images/ring.png');
    },
    create: function() {
        this.physics.startSystem(Phaser.Physics.ARCADE);
        
        this.gnome = this.add.image(this.world.centerX - 20, this.world.centerY - 20, 'gnome');
        this.gnome.scale.x = .1;
        this.gnome.scale.y = .1;
        
        this.scale.minWidth = 270;
		this.scale.minHeight = 480;

		this.input.addPointer();
		this.stage.backgroundColor = '#000000';
        
        this.buildRings();
        this.buildEmitters();
        this.input.onDown.add(this.doSpellEffects, this);
        
        var style = { font: "20px Arial", fill: "#ff0044", wordWrap: false, align: "center",  backgroundColor: "#ffff00" };
        this.text = this.add.text(this.world.centerX, 20, "Click Anywhere To Cast", style);
        this.text.anchor.set(0.5);
    },
    buildRings:function() {
        this.ringGroup = this.add.group();
        this.ringGroup.enableBody = true;
        
        var r1 = this.ringGroup.create(this.gnome.x - 80, this.gnome.y -80, 'ring');
        r1.scale.x = .7;
        r1.scale.y = .7;
        
        var r2 = this.ringGroup.create(this.gnome.x + 80, this.gnome.y -70, 'ring');
        r2.scale.x = .2;
        r2.scale.y = .7;
        r2.angle = 45;
        
        var r3 = this.ringGroup.create(this.gnome.x - 80, this.gnome.y -20, 'ring');
        r3.scale.x = .2;
        r3.scale.y = .7;
        r3.angle = -45;
        
        this.ringGroup.visible = false;
    },
    buildEmitters:function() {
        
        var emitters = [];
        var game = this;
        
        var ring = this.ringGroup.getFirstExists();
        
        var numChops = 40;
        var modifier = 40; //still trying to figure out how not to have to do this
        var radius = ring.body.halfWidth - modifier;
        for (var i = 0; i < numChops; i++) {
            var x = (ring.body.center.x + radius * Math.cos(2 * Math.PI * i / numChops)) - modifier;
            var y = (ring.body.center.y + radius * Math.sin(2 * Math.PI * i / numChops)) - modifier;
            emitters.push(this.buildEmitter(x, y));
        }
        
        this.spellEffects = emitters;
    },
    buildEmitter:function(x, y) {
        var emitter = this.add.emitter(x, y, 200);

        emitter.minParticleSpeed.setTo(-30, 30);
        emitter.maxParticleSpeed.setTo(30, -30);
        emitter.makeParticles('sparkle');
        emitter.minParticleScale = 0.01;
        emitter.maxParticleScale = 0.1;
        
        return emitter;
    },
    doSpellEffects: function(listener, listenerContext, priority, counter) {
        this.ringGroup.visible = true;
        var counter = counter || 0;
        this.spellEffects.forEach(function(e){ 
           e.start(true, 2000, null, 20); 
        });
        
        var game = this;
        if (counter < 6)
        {
            setTimeout(function(){ 
                game.doSpellEffects(listener, listenerContext, priority, counter+1);
            }, 500);
        }
        else
        {
            this.ringGroup.visible = false;
        }
    },
};